require 'sqlite3' #the rb-sqlite3 MacPort

#close ActionTastic before import!
#imports completed actions, so clean those away beforehand
#set the bucket attribute on the *Single Actions projects afterwards
#run as:
#ruby "ActionTastic to OmniFocus.rb" | iconv -f UTF8 -t MacRoman -c | osascript
#iconv as osascript doesn't like UTF8
#-c as iconv doesn't know MacRoman with Euro-Symbol

class String
  def asquote
    self.gsub(/"/, '\"')
  end
end

db = SQLite3::Database.new('/Users/towb/Library/Application Support/Actiontastic/Actiontastic.sqlite')

puts 'tell application "OmniFocus"'

puts 'tell first document'

db.execute("select Z_PK, ZNAME from ZCONTEXT order by ZNAME asc") do |id, name|
  puts "set oc#{id} to (make new context with properties {name:\"#{name.asquote}\"})"
end

db.execute("select Z_PK, ZNAME from ZINBOXITEM order by ZORDER asc") do |id, name| #without id name is Array
  puts "make new inbox task with properties {name:\"#{name.asquote}\"}"
end

db.execute("select Z_PK, ZNAME from ZPROJECT order by ZNAME asc") do |id, name|
  puts "set op#{id} to (make new project with properties {name:\"#{name.asquote}\"})"
end

puts 'end tell' #first document

lastProject = nil
db.execute("select ZNAME, ZPROJECT, ZCONTEXT from ZACTION order by ZPROJECT asc, ZPROJECTORDER asc") do |name, project, context|
  if project != lastProject then
    puts 'end tell' unless lastProject == nil
    puts "tell op#{project}"
  end
  lastProject = project
  puts "make new task with properties {name:\"#{name.asquote}\", context:oc#{context}}"
end
puts 'end tell' unless lastProject == nil

puts 'end tell' #application